# -*- coding: utf-8 -*-
#
# Configuration file for the Sphinx documentation builder.
#
# This file does only contain a selection of the most common options. For a
# full list see the documentation:
# http://www.sphinx-doc.org/en/stable/config

# -- Path setup --------------------------------------------------------------

# If extensions (or modules to document with autodoc) are in another directory,
# add these directories to sys.path here. If the directory is relative to the
# documentation root, use os.path.abspath to make it absolute, like shown here.
#
import os
import shutil
import sys
from pathlib import Path

# import sys
# sys.path.insert(0, os.path.abspath('.'))

# -- Copy resources for documentation
docs_dir = Path(__file__).parent.parent / "doc"
try: 
    if os.path.exists(str(docs_dir / "_build" / "html" / "img")):
        shutil.rmtree(str(docs_dir / "_build" / "html" / "img"))
    # doesn't exists
    shutil.copytree(
    str(Path(__file__).parent.parent / "doc" / "img"),
    str(docs_dir / "_build" / "html" / "img"))
except Exception as e:
    print('COPYERR', e)
else:
	pass
try: 
    if os.path.exists(str(docs_dir / "_build" / "html" / "_images")):
        shutil.rmtree(str(docs_dir / "_build" / "html" / "_images"))
    # doesn't exists
    shutil.copytree(
    str(Path(__file__).parent.parent / "doc" / "img"),
    str(docs_dir / "_build" / "html" / "_images"))
except Exception as e:
    print('COPYERR', e)
else:
	pass
try:
    # dosn't exists
    shutil.copyfile(
    str(Path(__file__).parent.parent / "doc" / "TS_SPombe_4_R2.mp4"),
    str(docs_dir / "_build" / "html" / "TS_SPombe_4_R2.mp4"))
except Exception as e:
    print('COPYERR', e)
else:
	pass


# -- Project information -----------------------------------------------------

project = "{}\u00b2".format('Trac')
copyright = '2021, Andreas P. Cuny. All Rights Reserved'
author = 'Andreas P. Cuny'

# The short X.Y version
version = '1'
# The full version, including alpha/beta/rc tags
release = '1'

# -- General configuration ---------------------------------------------------

# If your documentation needs a minimal Sphinx version, state it here.
#
# needs_sphinx = '1.0'

# Add any Sphinx extension module names here, as strings. They can be
# extensions coming with Sphinx (named 'sphinx.ext.*') or your custom
# ones.
extensions = ['sphinx.ext.autodoc', 
			  'sphinxcontrib.matlab',
			  'sphinx.ext.napoleon',
			  'sphinx.ext.mathjax',
			  'sphinx.ext.todo',
			  'sphinx.ext.githubpages',
			  'sphinx_markdown_tables',
			  'texext.math_dollar',  
			  'sphinx.ext.autosummary',
              'sphinx.ext.githubpages',		  
			  ]
			  
#matlab_src_dir = os.path.dirname(os.path.abspath('src'))
this_dir = os.path.dirname(os.path.abspath(__file__))
matlab_src_dir = os.path.abspath(os.path.join(this_dir, '../src'))
primary_domain = 'mat'

autodoc_default_options = {'members': True, 'show-inheritance': True}
autosummary_generate = True

# Add any paths that contain templates here, relative to this directory.
templates_path = ['_templates']

# The suffix(es) of source filenames.
# You can specify multiple suffix as a list of string:
#
# source_suffix = ['.rst', '.md']
source_suffix = ['.rst', '.md']

# The master toctree document.
master_doc = 'index'

# The language for content autogenerated by Sphinx. Refer to documentation
# for a list of supported languages.
#
# This is also used if you do content translation via gettext catalogs.
# Usually you set "language" from the command line for these cases.
language = None

# List of patterns, relative to source directory, that match files and
# directories to ignore when looking for source files.
# This pattern also affects html_static_path and html_extra_path .
exclude_patterns = ['_build', 'Thumbs.db', '.DS_Store']

# The name of the Pygments (syntax highlighting) style to use.
pygments_style = 'sphinx'


# -- Options for HTML output -------------------------------------------------

# The theme to use for HTML and HTML Help pages.  See the documentation for
# a list of builtin themes.
#
#html_theme = 'sphinx_rtd_theme'
html_theme = 'press'

# Theme options are theme-specific and customize the look and feel of a theme
# further.  For a list of options available for each theme, see the
# documentation.
#
#html_theme_options = {'logo_only': True,}

# Add any paths that contain custom static files (such as style sheets) here,
# relative to this directory. They are copied after the builtin static files,
# so a file named "default.css" will overwrite the builtin "default.css".
# html_static_path = ['_static']

# Custom sidebar templates, must be a dictionary that maps document names
# to template names.
#
# The default sidebars (for documents that don't match any pattern) are
# defined by theme itself.  Builtin themes are using these templates by
# default: ``['localtoc.html', 'relations.html', 'sourcelink.html',
# 'searchbox.html']``.
#
# html_sidebars = {}

# The name of an image file (relative to this directory) to place at the top
# of the sidebar.
html_logo = 'TrackerLogo.png'


# -- Options for HTMLHelp output ---------------------------------------------

# Output file base name for HTML help builder.
htmlhelp_basename = 'sphinxcontrib-matlabdomaindoc'


# -- Options for LaTeX output ------------------------------------------------

latex_elements = {
    # The paper size ('letterpaper' or 'a4paper').
    #
    # 'papersize': 'letterpaper',

    # The font size ('10pt', '11pt' or '12pt').
    #
    # 'pointsize': '10pt',

    # Additional stuff for the LaTeX preamble.
    #
    # 'preamble': '',

    # Latex figure (float) alignment
    #
    # 'figure_align': 'htbp',
}

# Grouping the document tree into LaTeX files. List of tuples
# (source start file, target name, title,
#  author, documentclass [howto, manual, or own class]).
latex_documents = [
    (master_doc, 'sphinxcontrib-matlabdomain.tex', "{}\u00b2".format('Trac') + 'Documentation',
     'Andreas P. Cuny', 'manual'),
]


# -- Options for manual page output ------------------------------------------

# One entry per manual page. List of tuples
# (source start file, name, description, authors, manual section).
man_pages = [
    (master_doc, 'sphinxcontrib-matlabdomain', "{}\u00b2".format('Trac') + 'Documentation',
     [author], 1)
]


# -- Options for Texinfo output ----------------------------------------------

# Grouping the document tree into Texinfo files. List of tuples
# (source start file, target name, title, author,
#  dir menu entry, description, category)
texinfo_documents = [
    (master_doc, 'sphinxcontrib-matlabdomain', "{}\u00b2".format('Trac') + 'Documentation',
     author, 'Andreas P. Cuny', '2D cell tracking.',
     'Image Processing software'),
]